#ifndef __INPUT_HEADER_FILE
#define __INPUT_HEADER_FILE

enum
{
											PLAYER1_LEFT,
											PLAYER1_RIGHT,
											PLAYER1_UP,
											PLAYER1_DOWN,
											PLAYER1_BUTTON1,
											PLAYER1_BUTTON2,
											PLAYER1_START,
											PLAYER2_LEFT,
											PLAYER2_RIGHT,
											PLAYER2_UP,
											PLAYER2_DOWN,
											PLAYER2_BUTTON1,
											PLAYER2_BUTTON2,
											PLAYER2_START,
											NO_OF_BUTTONS
};

#define JOYSTICK_RANGE						1000

// Rapid fire every x frames
#define RAPID_FIRE_RATE						4

#define MAX_JOYSTICKS						8
#define MAX_JOYSTICK_BUTTONS				32

typedef struct JOYSTICK_INFO
{
	LPDIRECTINPUTDEVICE7					pDevice;
	char									Name[MAX_PATH];
	BOOL									Acquired;
} JOYSTICK_INFO;

BOOL										InitInput(HWND, HINSTANCE);
void										TidyInput(void);
void										AcquireKeyboard(void);
void										UnacquireKeyboard(void);
void										UpdateKeyboard(void);
char										*ButtonToString(int);
int											GetKeyPressed(BOOL);
void										SetControlKey(int, int);
BOOL FAR PASCAL								EnumJoysticks(LPCDIDEVICEINSTANCE, LPVOID *);
void										AcquireJoystick(int);
void										UnacquireJoystick(int);
void										UpdateJoysticks(void);
BOOL										JoystickPresent(void);
int											GetJoystickButtonPressed(void);
BOOL										GetJoystickName(int, char *);
int											GetSelectedJoystick(int);
void										SetSelectedJoystick(int, int);
int											FindJoystick(int);
void										UpdateSpecialKeys(void);
void										UpdateRapidFire(unsigned int);

#endif