#ifndef __REGISTRY_HEADER
#define __REGISTRY_HEADER

#define REGISTRY_KEY						"\\SMS Plus"

#define REGISTRY_DEFAULT_SCREEN_SCALE		1
#define REGISTRY_DEFAULT_UPDATE_FREQUENCY	FREQ_60HZ
#define REGISTRY_DEFAULT_FRAME_SKIP			0
#define REGISTRY_DEFAULT_BUTTON_MAP			{DIK_LEFT, DIK_RIGHT, DIK_UP, DIK_DOWN, DIK_LCONTROL, DIK_LSHIFT, DIK_SPACE, 0, 0, 0, 0, 0, 0, 0}
#define REGISTRY_DEFAULT_ROM_PATH			"C:\\"
#define REGISTRY_DEFAULT_SCREENSHOT_PATH	"C:\\"
#define REGISTRY_DEFAULT_SOUND_ENABLE		TRUE
#define REGISTRY_DEFAULT_SOUND_FREQUENCY	44100

#define REGISTRY_SCREEN_SCALE				"Screen Scale"
#define REGISTRY_UPDATE_FREQUENCY			"Update Frequency"
#define REGISTRY_FRAME_SKIP					"Frame Skip"
#define REGISTRY_BUTTON_MAP					"Button Map"
#define REGISTRY_ROM_PATH					"ROM Path"
#define REGISTRY_SRAM_PATH					"SRAM Path"
#define REGISTRY_SCREENSHOT_PATH			"Screenshot Path"
#define REGISTRY_JOYSTICK					"Joystick"
#define REGISTRY_JOYSTICK_MAP				"Joystick Map"
#define REGISTRY_SOUND_ENABLE				"Enable Sound"
#define REGISTRY_SOUND_FREQUENCY			"Sound Frequency"
#define REGISTRY_RAPID_FIRE					"Rapid Fire"

typedef struct REGISTRY_INFO
{
	unsigned int							ScreenScale;
	unsigned int							UpdateFrequency;
	unsigned int							FrameSkip;
	unsigned char							ButtonMap[NO_OF_BUTTONS];
	char									ROMPath[MAX_PATH];
	char									SRAMPath[MAX_PATH];
	char									ScreenshotPath[MAX_PATH];
	char									Joystick[MAX_PLAYERS][MAX_PATH];
	unsigned char							JoystickMap[MAX_PLAYERS][3];
	BOOL									EnableSound;
	int										SoundFrequency;
	unsigned char							RapidFire[MAX_PLAYERS][2];
} REGISTRY_INFO;

extern REGISTRY_INFO						RegistryInfo;

void										InitRegistryEntries(void);
BOOL										LoadRegistryEntries(void);
BOOL										SaveRegistryEntries(void);
void										SetFileAssociations(void);

#endif